#ifdef __CINT__

#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;

#pragma link C++ class TMaple;

#pragma link C++ enum eStochasticType;
#pragma link C++ enum eEstimateNumSymbols;
#pragma link C++ enum eCorrFilterMethod;
#pragma link C++ enum eXCorr_Options;	
#pragma link C++ enum eSignalDumpMode;
#pragma link C++ class TDSPRating;
#pragma link C++ class TDSPStochasticProcess;
#pragma link C++ class TDSPStochasticScalar;
#pragma link C++ class TDSPStatistics;
#pragma link C++ class TDSPBlockfft;
#pragma link C++ class TDSPBlockMap;
#pragma link C++ class TDSPFilterMap;
#pragma link C++ class TDSPBlockSolve;
#pragma link C++ class TDSPChop;
#pragma link C++ class TDSPConvolution;
#pragma link C++ class TDSPData;
#pragma link C++ class TDSPGenerator;
#pragma link C++ class TDSPGroup;
#pragma link C++ class TDSPHarmonicGenerator;
#pragma link C++ class TDSPInt;
#pragma link C++ class TDSPNofdm;
#pragma link C++ class TDSPFMT;
#pragma link C++ class TDSPOfdm;
#pragma link C++ class TDSPOperator;
#pragma link C++ class TDSPOutput1;
#pragma link C++ class TDSPSignalStudy;
#pragma link C++ class TDSPPsk;
#pragma link C++ class TDSPQam;
#pragma link C++ class TDSPPam;
#pragma link C++ class TDSPFastBpsk;
#pragma link C++ class TDSPFastQpsk;
#pragma link C++ class TDSPReadSignal;
#pragma link C++ class TDSPSignal;
#pragma link C++ class TDSPSignalDump;
#pragma link C++ class TDSPSpectrum;
#pragma link C++ class TDSPStft;
#pragma link C++ class TDSPStochasticSignal;
#pragma link C++ class TDSPSymbolGenerator;
#pragma link C++ class TDSPfft;
#pragma link C++ class TDSPJakes;
#pragma link C++ class TDSPCorrelationFilter;
#pragma link C++ class TDSPFilter;
#pragma link C++ class TDSPFifo;
#pragma link C++ class TDSPBlockFifo;
#pragma link C++ class TDSPBlockFifoFilter;
#pragma link C++ class TDSPFilterBank;
#pragma link C++ class TDSPFifoFilter;

#pragma link C++ class TDSPFunction;
#pragma link C++ class TDSPClip;
#pragma link C++ class TDSPMath;
#pragma link C++ class TDSPModulation;
#pragma link C++ class TDSPWienerProcess;

#pragma link C++ class TDSPEstimator;
#pragma link C++ class TDSPLmmse;

#pragma link C++ class TDSPSource;
#pragma link C++ class TDSPMonitor;

// friend TDSPSignal functions

#pragma link C++ function operator>>(istream&,TDSPSignal&);
#pragma link C++ function operator<<(ostream&,TDSPSignal&);
#pragma link C++ function operator>>(istream&,TDSPSignal*);
#pragma link C++ function operator<<(ostream&,TDSPSignal*);

// friend TDSPSource functions

#pragma link C++ function operator==(TDSPSource&,TDSPSource&);

// friend TDSPFifo functions

#pragma link C++ function filter(TDSPFifo*,TDSPSignal*,TDSPSignal*, TDSPSignal*);
#pragma link C++ function filter(TDSPFifo*,TDSPFifo*,TDSPSignal*, TDSPSignal*);
#pragma link C++ function operator>>(istream&,TDSPFifo&);
#pragma link C++ function operator<<(ostream&,TDSPFifo&);
#pragma link C++ function operator>>(istream&,TDSPFifo*);
#pragma link C++ function operator<<(ostream&,TDSPFifo*);
#pragma link C++ function dB(Double_t);
#pragma link C++ function FromdB(Double_t);
		       
#pragma link C++ function CheckEnter();

#pragma link C++ function Modulator(Option_t*,Int_t);

// Global Variables/Functions fft/blockfft

#pragma link C++ global   gFFT;
#pragma link C++ function fft(TDSPVector*,Int_t,TDSPVector*);
#pragma link C++ function ifft(TDSPVector*,Int_t,TDSPVector*);
#pragma link C++ function fft(TDSPMatrix*,Int_t,TDSPMatrix*);
#pragma link C++ function ifft(TDSPMatrix*,Int_t,TDSPMatrix*);

#pragma link C++ global   gBlockFFT;
#pragma link C++ function blockfft(TDSPVector*,Int_t,TDSPVector*);
#pragma link C++ function blockifft(TDSPVector*,Int_t,TDSPVector*);

// Global TDSPMath-Constants

#pragma link C++ global   Pi;

#endif
