/** TDSP *******************************************************************
                          TDSPBlockFifoFilter.h  -  description
                             -------------------
    begin                : Thu Jan 10 2002
    copyright            : (C) 2002 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPBLOCKFIFOFILTER_H
#define TDSPBLOCKFIFOFILTER_H

#include "TDSPFilter.h"
#include "TDSPBlockFifo.h"

/**FIFO-Filtering
 * for Blocks (based on TDSPBlockFifo)
 * @author Peter Jung
 */

class TDSPBlockFifoFilter   {


 protected:

  TDSPFilter *fFilter;

  Int_t       fWidth;

  TDSPBlockFifo *fInput;
  TDSPBlockFifo *fOutput;
  
  void ConfigFifos();

 public: 


  
  TDSPBlockFifoFilter(char *name = NULL);
  virtual ~TDSPBlockFifoFilter();

  TDSPBlockFifo *GetInputFifo() { return fInput; };
  TDSPBlockFifo *GetOutputFifo() { return fOutput; };

  void        SetFilter(TDSPFilter*);
  TDSPFilter* GetFilter() const { return fFilter;};

  void SetWidth(Int_t);

  TDSPSignal *filter(TDSPSignal *input, TDSPSignal *output);
 
  ClassDef(TDSPBlockFifoFilter,1)
  
};

#endif
