/** TDSP *******************************************************************
                          TDSPChop.h  -  description
                             -------------------
    begin                : Tue Nov 13 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPCHOP_H
#define TDSPCHOP_H

#include <TDSPSignal.h>
#include <TDSPOutput1.h>

/**Chops the input signal
  *@author Peter Jung
  */

class TDSPChop : public TDSPOutput1  {
  
  // the last set output signal length

  Int_t       fSignalLength;

  // The size of the cached data
  
  Int_t       fFilled;

 protected:

 public: 


  TDSPChop(char *name);
  ~TDSPChop();

  // Set the length of the output signal

  void SetSignalLength(Int_t len) { GetSignal()->SetLen(fSignalLength = len); };

  // register signals and Slots

  void RegisterSignalsAndSlots() {}


  // Slots

  TDSPSignal* Update(TDSPSignal *input);

  ClassDef(TDSPChop,1)

};

#endif
