/** TDSP *******************************************************************
                          TDSPEstimator.h  -  description
                             -------------------
    begin                : Mon Apr 29 2002
    copyright            : (C) 2002 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPESTIMATOR_H
#define TDSPESTIMATOR_H

#include <TQQObject.h>
#include <TDSPVector.h>
#include <TDSPMatrix.h>

/**Base Class for
   Estimators
   *@author Peter Jung
   */

class TDSPEstimator : public TQQObject  {
 protected:
  TDSPVector* fEstimate;
  
 public: 
  TDSPEstimator();
  ~TDSPEstimator();

  TDSPVector *GetEstimate() const { return fEstimate;};

  virtual TDSPVector* Estimate(TDSPVector* y) { return y;};
  virtual void        Calculate() = 0;
  ClassDef(TDSPEstimator,1)

};


#endif
