/** TDSP *******************************************************************
                          TDSPFifoFilter.h  -  description
                             -------------------
    begin                : Thu Jan 10 2002
    copyright            : (C) 2002 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPFIFOFILTER_H
#define TDSPFIFOFILTER_H

#include <TDSPFilter.h>
#include <TDSPFifo.h>

/**FIFO-Filtering
 * (based on TDSPFifo)
 * @author Peter Jung
 */

class TDSPFifoFilter  {


 protected:

  TDSPFilter *fFilter;

  TDSPFifo *fInput;
  TDSPFifo *fOutput;
  
 public: 


  
  TDSPFifoFilter();
  virtual ~TDSPFifoFilter();

  TDSPFifo *GetInputFifo() { return fInput; };
  TDSPFifo *GetOutputFifo() { return fOutput; };

  void         SetFilter(TDSPFilter*);
  TDSPFilter*  GetFilter() const { return fFilter;};
  virtual void Reset();
  TComplex     filter(TComplex  input);

  Double_t     GetRate() { return fFilter->GetRate(); };
 
  ClassDef(TDSPFifoFilter,1)
  
};

inline TComplex TDSPFifoFilter::filter(const TComplex  input) {
  TComplex value;
  fInput->Shift(input);
  fOutput->Shift(value = fFilter->filter(fInput,fOutput));
  return value;
}


#endif
