/** TDSP *******************************************************************
                          TDSPGroup.h  -  description
                             -------------------
    begin                : Fri Nov 2 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPGROUP_H
#define TDSPGROUP_H

#include <TList.h>
#include <TDSPOperator.h>
#include <TQQGControl.h>

/**a group of operators and its cabling
  *@author Peter Jung
  */

class TDSPGroup : public TDSPOperator  {
  
  TList *fListOfOperators;

 public: 
  TDSPGroup(char *name = NULL);
  ~TDSPGroup();

  TList *GetListOfOperators()   { return fListOfOperators; };
  void   Add(TDSPOperator*o)    { fListOfOperators->Add(o);   Update(); };
  void   Remove(TDSPOperator*o) { fListOfOperators->Remove(o);Update(); };
  void   Print(); 

  virtual TQQGControl* NewGControl(); ///< opens a new graphical control 

  ClassDef(TDSPGroup,1)

};

#endif
