/** TDSP *******************************************************************
                          TDSPHarmonicGenerator.h  -  description
                             -------------------
    begin                : Mon Sep 10 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPHARMONICGENERATOR_H
#define TDSPHARMONICGENERATOR_H

#include <TDSPGenerator.h>
#include <TDSPSpectrum.h>
#include <TDSPSignal.h>
#include <TDSPOutput1.h>

/**
  *@author Peter Jung
  */

class TDSPHarmonicGenerator : public TDSPGenerator, public TDSPOutput1  {
 
  
  // the spectrum

  TDSPSpectrum *Spectrum;

 protected:
  
  void Fill(void);
  // my Slots

  TString Slot_Generate;

 public: 


  TDSPHarmonicGenerator(char *name);
  ~TDSPHarmonicGenerator();

  void  RegisterSignalsAndSlots() {
    
    // Add the Slots
    
    Slot_Generate  = AddSlot("Generate()");
  
  }
  
  TDSPSpectrum* GetSpectrum() { return Spectrum; };
 
  void SetSignalLength(Int_t num) { GetSignal()->SetLen(num);};

  void          Generate() { 
    Fill(); 
    Emit(Signal_NewData,GetSignal());
  }; // *SIGNAL*

  // here we have to implement a streamer - later !!!

  ClassDef(TDSPHarmonicGenerator,1)

};

#endif
