/** TDSP *******************************************************************
                          TDSPMonitor.h  -  description
                             -------------------
    begin                : Sam Aug 3 2002
    copyright            : (C) 2002 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPMONITOR_H
#define TDSPMONITOR_H

#include <TList.h>
#include <TDSPOperator.h>
#include <TDSPBlockOperation.h>

/**Monitor
 *@author Peter Jung
 */

class TDSPMonitor : public TDSPOperator, public TDSPBlockOperation  {
 protected:
  
  TString Slot_Update;
  TList   fSignalList;
  Int_t   fBlockLen;

 public: 

  TDSPVector fMSE;

  TDSPMonitor(char *name=NULL);
  ~TDSPMonitor();


  void   SetBlockLen(Int_t b) { fBlockLen = b;};
  Int_t  GetBlockLen() { return fBlockLen; };

  TDSPSignal* GetNamedSignal(char *);
  virtual void Monitor(char *);

  // the slot

  void Update(TDSPSignal*);

  ClassDef(TDSPMonitor,1)

};

#endif
