/** TDSP *******************************************************************
                         TDSPPam.h  -  description
                             -------------------
    begin                : Mon Nov 19 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPPAM_H
#define TDSPPAM_H

#include <TRandom.h>
#include <TDSPSymbolGenerator.h>

/**a Pam Generator and ML-Analyser
 *@author Peter Jung
 */


class TDSPPam : public TDSPSymbolGenerator {

 protected:
  
  virtual void     InitSymbols();

 public: 
  
  TDSPPam(char *name, 
	  Int_t = 4,
	  UInt_t = kDEFAULT_OPTIONS);
  ~TDSPPam();

  // Theoretics

  Double_t SER(Double_t SNR);

  ClassDef(TDSPPam,1)

};

#endif
