/** TDSP *******************************************************************
                          TDSPReadSignal.h  -  description
                             -------------------
    begin                : Wed Nov 14 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPREADSIGNAL_H
#define TDSPREADSIGNAL_H

#include <Riostream.h>
#include <TDSPGenerator.h>
#include <TDSPOutput1.h>

/**simple readline input interface for signal
   generation
   *@author Peter Jung
   */

class TDSPReadSignal : public TDSPOutput1, public TDSPGenerator  {

  istream *is; //!

 protected:
  
  TString Slot_Generate;

 public: 
  TDSPReadSignal(char *name) : TDSPOutput1(name) {
    // My Slot
    Slot_Generate = AddSlot("Generate()");
    is = &cin;
  }
  ~TDSPReadSignal();

  // My Slots

  void Generate();
  
  ClassDef(TDSPReadSignal,1)
    
};

#endif
