/** TDSP *******************************************************************
                          TDSPSignalDump.h  -  description
                             -------------------
    begin                : Wed Nov 14 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPSIGNALDUMP_H
#define TDSPSIGNALDUMP_H

#include <Riostream.h>

#include <TDSPSignal.h>
#include <TDSPOperator.h>

/**a simple ascii signal dumper
 *@author Peter Jung
 */

enum eSignalDumpMode {
  kSignalDumpAll,
  kSignalDumpParams
};

class TDSPSignalDump : public TDSPOperator  {
  
  ostream *os; //!
    
 protected:

  eSignalDumpMode fMode;   // Dump Mode
  Int_t           fPause;  // Pause (<0 - infinity , >0 in seconds)

  TString Slot_Update;
  
 public: 
  TDSPSignalDump(char *name = NULL);
  ~TDSPSignalDump();

  void            SetMode(eSignalDumpMode e) { fMode = e;};
  eSignalDumpMode GetMode() const { return fMode;};
  
  void            SetPause(Int_t sec) { fPause = sec;};
  Int_t           GetPause() const { return fPause;};

  // Slots

  void Update(TDSPSignal*);

  ClassDef(TDSPSignalDump,0)

};

#endif
