/** TDSP *******************************************************************
                          TDSPSource.h  -  description
                             -------------------
    begin                : Sam Aug 3 2002
    copyright            : (C) 2002 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPSOURCE_H
#define TDSPSOURCE_H

#include <TNamed.h>
#include <TQQObject.h>
#include <TDSPSignal.h>

/**a source for a signal
  *@author Peter Jung
  */

class TDSPSource : public TNamed  {
 protected:

  TQQObject   *fSender; //!
  TDSPSignal  *fSignal; //!

 public: 
  TDSPSource();
  ~TDSPSource();

  virtual void        SetSender(TQQObject*);
  virtual TQQObject*  GetSender() const { return fSender;};
  virtual void        SetSignal(TDSPSignal*);
  virtual TDSPSignal* GetSignal() const { return fSignal;};
  
  friend Bool_t      operator==(TDSPSource &, TDSPSource &);

  ClassDef(TDSPSource,1)

};


#endif
