/** TDSP *******************************************************************
                          TDSPSpectrum.h  -  description
                             -------------------
    begin                : Thu Nov 1 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPSPECTRUM_H
#define TDSPSPECTRUM_H

#include <TDSPData.h>

/**complex spectrum
  *@author Peter Jung
  */

class TDSPSpectrum : public TDSPData  {

  Int_t         Num;         //!
  TComplex     *Frequencies; //!
  TComplex     *Amplitudes;  //!


  // The Cache-Effect
  Int_t         fMinAlloc;
  Double_t      fAllocHighScale;         //  Alloc more memory we really need to avoid many alloc if we resize the block 
  Double_t      fAllocLowScale;          //  Alloc more memory we really need to avoid many alloc if we resize the block 
 
  Int_t         fAllocedNum;         //! Size of intern alloced data blocks
  TComplex     *fAllocedFrequencies; //! 
  TComplex     *fAllocedAmplitudes;  //!

 public: 
  TDSPSpectrum();
  ~TDSPSpectrum();

  void         AddFreqAmp(TComplex f,
			  TComplex a);

  void         SetFreqAmp(Int_t  num, 
			  TComplex *f,
			  TComplex *a);
  
  void         SetNum(Int_t);
  Int_t        GetNum() { return Num; };
  TComplex*    GetFrequencies() { return Frequencies; };
  TComplex*    GetAmplitudes() { return Amplitudes; };
  
  
  ClassDef(TDSPSpectrum,1)
};

#endif
