/** TDSP *******************************************************************
                          TDSPGroupControl.h  -  description
                             -------------------
    begin                : Mon Nov 5 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPGROUPCONTROL_H
#define TDSPGROUPCONTROL_H

#include <TQQObjectControl.h>
#include <TDSPGroup.h>
#include <TDSPOperator.h>
#include <TDSPOperatorControl.h>
/**Base Class for a group control element
  *@author Peter Jung
  */

class ControlOperatorConnection : public TObject {

 public:
  ControlOperatorConnection(TDSPOperator *o = NULL){ Operator = o; Control = NULL; };
  ~ControlOperatorConnection() {};
  TDSPOperator         *Operator;
  TDSPOperatorControl  *Control;
};




class TDSPGroupControl : public TQQObjectControl  {
  
  // The List of embedded Controls to each Operator in the group

  TList *fOperatorControls;

 public: 
  TDSPGroupControl();
  ~TDSPGroupControl();

  TList *GetListOfControls() { return fOperatorControls;};
  void ExploreGroup();

  virtual void SetObject(TDSPOperator *o) {
    TQQObjectControl::SetObject(o);
    ExploreGroup();
  };

  virtual void PrintComponents();
  virtual void Print();
 
  ClassDef(TDSPGroupControl,1)

};

#endif
