/** TDSP *******************************************************************
                          TDSPGroupGControl.h  -  description
                             -------------------
    begin                : Mon Nov 5 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TDSPGROUPGCONTROL_H
#define TDSPGROUPGCONTROL_H
#include <TGWindow.h>
#include <TGListTree.h>
#include <TDSPOperatorGControl.h>
#include <TDSPGroupControl.h>
#include <TDSPGroup.h>
#include <TQQGControl.h>

/**Graphical Control of a TDSPGroup-Object
  *@author Peter Jung
  */


#define kBrowserComponent 1

class TDSPGroupGControl :  public TQQGControl, public TDSPGroupControl {
  
  TDSPOperatorGControl *fGroupControl;           //!
  TGListTreeItem       *fComponentsListTreeItem; //!

 public: 
  TDSPGroupGControl(const TGWindow *parent = NULL, 
		    UInt_t w=150, 
		    UInt_t h=150, 
		    UInt_t options = 0);

  ~TDSPGroupGControl();
 
  virtual void Print();
  virtual void SetObject(TDSPOperator *o);
  virtual void ListTree(TGControlList  *list = NULL, 
			TGListTreeItem *parent = NULL);  

  // Slots

  virtual void HandlePopup(Int_t);
  
  // Signals and Slots
  virtual void Paint() { Emit("Paint()");};//*SIGNAL*
  
  ClassDef(TDSPGroupGControl,1)

};

#endif
