#ifdef __CINT__

#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;
#pragma link C++ class TDSPSolver;
#pragma link C++ class TDSPLinearSolver;
#pragma link C++ class TComplex-;
#pragma link C++ class TDSPVector-;
#pragma link C++ class TDSPMatrix;
#pragma link C++ class TDSPBlockOperation;

// Some enums

#pragma link C++ enum eLinearSolveMethod;
#pragma link C++ enum eMatrixApplyMode;

// friend Complex functions

#pragma link C++ function operator + (const Double_t,const TComplex&);
#pragma link C++ function operator - (const Double_t,const TComplex&);
#pragma link C++ function operator * (const Double_t,const TComplex&);
#pragma link C++ function operator * (const TComplex&,const TComplex&);
#pragma link C++ function operator % (const TComplex&,const TComplex&);
#pragma link C++ function operator / (const Double_t,const TComplex&);
#pragma link C++ function operator == (const TComplex&, const TComplex&);
#pragma link C++ function operator != (const TComplex&, const TComplex&);
#pragma link C++ function operator == (const TComplex&, const Double_t&);
#pragma link C++ function operator != (const TComplex&, const Double_t&);
#pragma link C++ function Abs(const TComplex&);
#pragma link C++ function Abs2(const TComplex&);
#pragma link C++ function Sqrt(const TComplex&);
#pragma link C++ function Sqrt3(const TComplex&, Int_t);
#pragma link C++ function Exp(const TComplex&);
#pragma link C++ function Log(const TComplex&);
#pragma link C++ function Log2(const TComplex&);
#pragma link C++ function Log10(const TComplex&);
#pragma link C++ function Sin(const TComplex&);
#pragma link C++ function Cos(const TComplex&);
#pragma link C++ function Power(const TComplex &,Int_t);
#pragma link C++ function Power(const TComplex &,Double_t);
#pragma link C++ function Phase(TComplex);
#pragma link C++ function operator>>(istream&,TComplex&);
#pragma link C++ function operator<<(ostream&,TComplex&);

#pragma link C++ function Dist(TComplex&,TComplex&);
// friend TDSPVector functions


#pragma link C++ function filter(TDSPVector*,TDSPVector*,TDSPVector*, TDSPVector*);
#pragma link C++ function filternorm(TDSPVector*,TDSPVector*, UInt_t);
#pragma link C++ function operator>>(istream&,TDSPVector&);
#pragma link C++ function operator<<(ostream&,TDSPVector&);
#pragma link C++ function operator>>(istream&,TDSPVector*);
#pragma link C++ function operator<<(ostream&,TDSPVector*);
#pragma link C++ function operator==(TDSPVector &, TDSPVector &);
#pragma link C++ function mult(TDSPVector*,TDSPVector*,TDSPVector*);
#pragma link C++ function econv(TDSPVector*,TDSPVector*,TDSPVector*,Int_t,Int_t,Int_t);
#pragma link C++ function Dist(TDSPVector*,TDSPVector*);
#pragma link C++ function Dist2(TDSPVector*,TDSPVector*);
#pragma link C++ function Dot(TDSPVector*,TDSPVector*,Bool_t);
#pragma link C++ function Dot2(TDSPVector*,TDSPVector*);
#pragma link C++ function Dist(TDSPVector&,TDSPVector&);
#pragma link C++ function Dist2(TDSPVector&,TDSPVector&);
#pragma link C++ function Dot(TDSPVector&,TDSPVector&,Bool_t);
#pragma link C++ function Dot2(TDSPVector&,TDSPVector&);
#pragma link C++ function Var(TDSPVector*,TDSPVector*);
#pragma link C++ function Var(TDSPVector&);
#pragma link C++ function Std(TDSPVector*);
#pragma link C++ function Std(TDSPVector&);
// friend TDSPMatrix functions


#pragma link C++ function operator>>(istream&,TDSPMatrix&);
#pragma link C++ function operator<<(ostream&,TDSPMatrix&);
#pragma link C++ function operator>>(istream&,TDSPMatrix*);
#pragma link C++ function operator<<(ostream&,TDSPMatrix*);
#pragma link C++ function Dist(TDSPMatrix*,TDSPMatrix*);
#pragma link C++ function Dist2(TDSPMatrix*,TDSPMatrix*);
#pragma link C++ function Dist(TDSPMatrix*,TDSPMatrix*);
#pragma link C++ function Dist2(TDSPMatrix*,TDSPMatrix*);
#pragma link C++ function Dot(TDSPMatrix*,TDSPMatrix*);
#pragma link C++ function Dot2(TDSPMatrix*,TDSPMatrix*);
#pragma link C++ function Dot(TDSPMatrix&,TDSPMatrix&);
#pragma link C++ function Dot2(TDSPMatrix&,TDSPMatrix&);

// other global TDSPVector functions

#pragma link C++ function Index(TComplex,TComplex,TComplex,TDSPVector*);
#pragma link C++ function Conv(TDSPVector*,TDSPVector*,TDSPVector*,Int_t);
#pragma link C++ function Rect(Int_t,Int_t,Double_t,TDSPVector*);
#pragma link C++ function Rect_FFTShift(Int_t,Int_t,Double_t,TDSPVector*);
#pragma link C++ function Gaussnk(Int_t,Double_t,TDSPVector*);
#pragma link C++ function Gaussnk_FFTShift(Int_t,Double_t,TDSPVector*);
#pragma link C++ function Rcos(Int_t,Int_t,Double_t,Double_t,TDSPVector*);
#pragma link C++ function Rcos_FFTShift(Int_t,Int_t,Double_t,Double_t,TDSPVector*);
#pragma link C++ function RandNC(UInt_t,Double_t);
#pragma link C++ function Delta(UInt_t,Int_t);

// other global TDSPMatrix functions

#pragma link C++ function Affine(TDSPMatrix*,TDSPVector*,TDSPVector*,TDSPVector*);
#pragma link C++ function Transform(TDSPMatrix*,TDSPMatrix*,TDSPMatrix*);
#pragma link C++ function UnitMatrix(Int_t,Int_t,TComplex);
#pragma link C++ function FlatMatrix(Int_t,Int_t,TComplex);
#pragma link C++ function ZeroMatrix(Int_t,Int_t);
#pragma link C++ function Zeros(Int_t,Int_t);
#pragma link C++ function Ones(Int_t,Int_t);
#pragma link C++ function Det(TDSPMatrix*);
#pragma link C++ function RowStack(TDSPVector*,Int_t,TDSPMatrix*);
#pragma link C++ function ColumnStack(TDSPVector*,Int_t,TDSPMatrix*);
#pragma link C++ function ConvMatrix(TDSPVector*,Int_t,Int_t,TDSPMatrix*,Bool_t,Int_t);
#pragma link C++ function ConvMatrix(TDSPMatrix*,Int_t,Int_t,TDSPMatrix*,Bool_t,Int_t,Int_t);
#pragma link C++ function Toeplitz(TDSPVector*,Int_t,Int_t,TDSPMatrix*,Bool_t);
#pragma link C++ function RandNC(UInt_t,UInt_t,Double_t);
#pragma link C++ global I;
#pragma link C++ global ComplexZero;

#endif
