/** TDSP *******************************************************************
                          MultiRate.h  -  description
                             -------------------
    begin                : Don Okt 24 2002
    copyright            : (C) 2002 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef  MULTIRATE_H
#define MULTIFATE_H

#include <TDSPVector.h>

#define MULTIRATE_SAMPLING_RAWMODE 0x1 

TDSPVector* DownSampling(TDSPVector *input,           // the input-signal
			 UInt_t M,                    // M-fold
			 TComplex   *pulse= NULL,     // adress to the pulse vector
			 UInt_t      hlen = 0,        // length of pulse-vector
			 Int_t      iZero = 0,        // position of the zero
			 TDSPVector *output = NULL,   // output vector 
			 UInt_t      NumStreams=1,      // number of parallel streams (serial-parallel conversion)
			 UInt_t      iStream=0,         // index of stream to process	
			 UInt_t      opt=0            // options
			 );


TDSPVector* UpSampling(TDSPVector *input,             // the input-signal
		       UInt_t      K,                 // K-fold
		       TComplex   *pulse = NULL,      // adress to the pulse vector  
		       UInt_t      hlen  = 0,         // length of pulse-vector
		       Int_t       iZero = 0,         // position of the zero
		       TDSPVector *output= NULL,      // output vecto
		       UInt_t      NumStreams=1,      // number of parallel streams (serial-parallel conversion)
		       UInt_t      iStream=0,         // index of stream to process				   
		       UInt_t      opt=0              // options
		       );


#endif
