/** TDSP *******************************************************************
                          TMatlab.h  -  description
                             -------------------
    begin                : Mon Jan 7 2002
    copyright            : (C) 2002 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TMATLAB_H
#define TMATLAB_H

//#ifndef ROOT_Varargs
#include <Varargs.h>
//#endif


#include <Riostream.h>




// If this code is in tdsp ....

#include <TQQObject.h>
#include <TDSPVector.h>

#include <TmxArray.h>

/**Wrapper Class for the Matlab Engine
 *@author Peter Jung
 */

class TMatlab : public TQQObject {
 protected:
  void     *fEngine;       //!
  char     *fOutputBuffer; //!
  Int_t     fEvalReturn;   // the Error Return Code of the last evaluation
 public: 

  friend istream    &operator>>(istream&,TMatlab&);
  //friend ostream    &operator<<(ostream&,TMatlab&);
  //friend istream    &operator>>(istream&,TMatlab*);
  //friend ostream    &operator<<(ostream&,TMatlab*);
  

  TMatlab();
  ~TMatlab();

  static    TMatlab* GlobalEngine();

  // Evalutions
  //
  Bool_t    Eval(const char* va_(fmt), ...);
  Bool_t    EvalString(const char* va_(fmt), ... );
  Int_t     OutputBuffer(char* buffer = NULL, Int_t buflen = 2048);

  // put/get arrays
  
  Int_t     Put(TmxArray *);
  TmxArray* Get(const char *name, TmxArray *a = NULL);
  
  ClassDef(TMatlab,1)

};

extern TMatlab* gMatlab;

#endif
