/** TDSP *******************************************************************
                          TGControlList.h  -  description
                             -------------------
    begin                : Wed Nov 7 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TGCONTROLLIST_H
#define TGCONTROLLIST_H

#include <TGListTree.h>
#include <TGMenu.h>

/**more functional tglisttree
  *@author Peter Jung
  */

class TGControlListItemUserData {
  
  TGPopupMenu *fContextMenu;
  void        *fObject; //! 
    
 public:

  TGControlListItemUserData() {  
    fContextMenu=NULL;
    fObject=NULL;
  };
  ~TGControlListItemUserData(){};
  
  TGPopupMenu *GetContextMenu() { return fContextMenu; };
  void         SetContextMenu(TGPopupMenu *p) { fContextMenu=p; };

  void        *GetObject()        { return fObject; };
  void         SetObject(void *o) { fObject = o;};

};


class TGControlList : public TGListTree {

  Event_t *fEvent;
  
 public:

  // Event Handling
  Bool_t HandleButton(Event_t*);

  // Slots
  void ToggleItem(TGListTreeItem*,Int_t);
  void ClickItem(TGListTreeItem*,Int_t);

  void OpenContextMenu(TGListTreeItem*);

  TGControlList(TGWindow *parent,
		UInt_t w = 300,
		UInt_t h = 150,
		UInt_t o = 0);
  ~TGControlList();

  TGControlListItemUserData*  UserData(TGListTreeItem* item);
  void                        ContextMenu(TGListTreeItem*,TGPopupMenu*);
  void                        SetObject(TGListTreeItem*,void*);
  void* GetObject(TGListTreeItem* i) {return UserData(i)->GetObject(); };

  TGClient*    GetClient() { return fClient; };

  ClassDef(TGControlList,0)

};

#endif
