/** TDSP *******************************************************************
                          TGTabDialog.h  -  description
                             -------------------
    begin                : Thu Nov 8 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TGTABDIALOG_H
#define TGTABDIALOG_H

#include <TGFrame.h>
#include <TGTab.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <TList.h>

/**Simple Dialog Window with Tabs (Cards)
  *@author Peter Jung
  */

class TGTabDialog : public TGTransientFrame  {

  const TGWindow            *fMain;
  TGCompositeFrame    *fBottomFrame;
  TGLayoutHints       *fL1,*fL2;
  TList               *fListOfTabs;
  TGButton            *fOkButton, *fCancelButton;
  TGTab               *fTab;

 
  

 public: 

  TList *GetListOfTabs() { return fListOfTabs; };
  
  TGTab *GetTab() { return fTab; };

  TGTabDialog(const TGWindow *p, 
	      const TGWindow *main, 
	      UInt_t w=500, UInt_t h = 300,
	      UInt_t options = kVerticalFrame);

  virtual void DrawDialog();
  virtual ~TGTabDialog();

  // Slots
  
  virtual void Ok();
  virtual void Apply();
  virtual void Cancel();
  virtual void CloseWindow();
  virtual void HandlePopup(Int_t);

  ClassDef(TGTabDialog,0)
};

#endif
