/** TDSP *******************************************************************
                          TDSPGControl.h  -  description
                             -------------------
    begin                : Wed Oct 31 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TQQGCONTROL_H
#define TQQGCONTROL_H

#include <TQObject.h>
#include <TGWindow.h>
#include <TGListTree.h>
#include <TGButton.h>
#include <TGCanvas.h>

#include <TQQObject.h>
#include <TGControlList.h>

/**Base Class for Graphical Control Elementr
 *@author Peter Jung
 */



class TQQGControl : public TQQObject  {

 protected:

  // Graphical ListTree 
  
  TGControlList     *fControlList;          //!
  TGListTreeItem    *fTopItem;              //!

  TGCanvas          *fCanvas;               //!

  
 public: 
  
  TGControlList*   GetControlList() { return fControlList; };
  TGListTreeItem*  GetFirstItem() { return fTopItem; };

  TGCanvas*        GetCanvas() { return fCanvas; };
  void             SetCanvas(TGCanvas* c) { fCanvas=c;};

  TQQGControl(const TGWindow *parent = NULL, 
	       UInt_t w=150, 
	       UInt_t h=150, 
	       UInt_t options = 0); // Own Canvas for the Object

  virtual  void ListTree(TGControlList  *list   = NULL,
			 TGListTreeItem *parent = NULL);
  

  virtual ~TQQGControl();

  ClassDef(TQQGControl,1)

};

#endif
