/** TDSP *******************************************************************
                          TDSPOperatorControl.h  -  description
                             -------------------
    begin                : Mon Nov 5 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TQQOBJECTCONTROL_H
#define TQQOBJECTCONTROL_H

#include <TBrowser.h>
#include <TQQObject.h>

/**Control for Operators

  *@author Peter Jung
  */

class TQQObjectControl  {

 protected:
  
  TQQObject *fObject;
  
 public: 
  TQQObjectControl();
  virtual ~TQQObjectControl();

  // Get/Set the Object to control 
  //
  virtual TQQObject *GetObject() { return fObject; };         // Get the Object to control 
  virtual void       SetObject(TQQObject *o) { fObject = o;}; // Set the Object to control 
  
  void Browse(TBrowser *b = NULL) {
    TQQObject *o = GetObject();
    if (!b) {
      b = new TBrowser("browse",o,o->GetName());
    } else
      o->Browse(b);
  }

  // The Slot used to tell the control that something changed in the
  // Object
  virtual void       Update() {};

  ClassDef(TQQObjectControl,1)

};

#endif
