{
gROOT->Reset();

#include <iostream.h>
TDSPSignal::ValuesPerLine(10);
TDSPFifo::ValuesPerLine(10);
			   
//////////////////////////////////////////////////////////////////

cout << endl << "Demonstrating the use of the simple Fifo" << endl << endl;

cout << "(1) Filling the Fifo \"fifo\"..." << endl;

fifo = new TDSPFifo();
fifo->SetDepth(5);

for(Int_t i=0;i<20;i++) {
  
  cout << "    ";
  if (!fifo->IsFull()) cout << "(not full) "; else cout << "(is full)  ";

  TComplex n = fifo->Shift(TComplex(i,0));
  cout << i << " --- ";
  if (fifo->WasFull()) cout << n.fRe << endl;
  else 
    cout << "(no value)" << endl;
  
}

//////////////////////////////////////////////////////////////////

cout << "(2) Define an FIR/IIR-filter " << endl;

fir = new TDSPSignal(2);
fir(0) = 1.000;       
fir(1) = -0.555;

iir = new TDSPSignal(4);
iir(0) = 1.000;                         
iir(1) = -1.464;
iir(2) = 0.701;
iir(3) = 0.076;

cout << "    FIR-Coeff: " << fir << endl;
cout << "    IIR-Coeff: " << iir << endl;

fil = new TDSPFilter();
fil->FIR(fir);
fil->IIR(iir);

//////////////////////////////////////////////////////////////////

cout << "(3) Mapping the Fifo Memory to a Signal \"a\"!" << endl;

a = new TDSPSignal();
*a=fifo;

cout << " fifo=" << fifo << endl;
cout << "    a=" << a << endl;
cout << "(4) Filtering \"a\" and \"fifo\" with the same FIR-Filter " << endl;

output = new TDSPSignal();

fil->filter(fifo,output);
cout << "    result is: " << output << endl;

fil->filter(a,output);
cout << "    result is: " << output << endl;


//////////////////////////////////////////////////////////////////

cout << "(5) Please compare the results of (4) - they must be equal !! " << endl;

//////////////////////////////////////////////////////////////////

TDSPFifo fifo1,fifo2;

cout << "(6) Filling \"fifo1\" width the values of \"fifo1\"" << endl;

fifo1->SetDepth(fifo->GetDepth());
fifo2->SetDepth(fifo->GetDepth());

TComplex value;
for(Int_t i=0;i<fifo->GetDepth();++i) {
  fifo1.Shift(fifo(i));
  cout << "Shift(" << fifo(i) << ") : ";
  cout << fifo1 << " : ";
  fifo2.Shift(value = fil->filter(&fifo1,&fifo2));
  cout << value << endl;
}



cout << "(7) Producing the same using TDSPFifoFilter " << endl;


TDSPFifoFilter fifofilter;
fifofilter->SetFilter(fil);

TComplex value;
for(Int_t i=0;i<fifo->GetDepth();++i) {
  cout << "Filter(" << fifo(i) << ") = ";
  value = fifofilter->filter(fifo(i));
  cout << value << endl;
}

}
