{
gROOT->Reset();
gErrorIgnoreLevel = kWarning;
#include <iostream.h>

//
/////////////////////////////////////////////////////////////
//
cout << endl << "/////////////////////////////////////////////////////////////" << endl;
cout << endl << "filter-implementation ... " << endl << endl;

//
/////////////////////////////////////////////////////////////
//
cout << "Creating an ARMA-Filter ..." << endl;
f = new TDSPFilter();

//
/////////////////////////////////////////////////////////////
//
fir = new TDSPSignal(2);
fir(0) =  1.0000;
fir(1) = -0.8405;
f->FIR(fir);

cout << "the FIR-part of the filter     : " << fir << endl;

//
/////////////////////////////////////////////////////////////
//
iir = new TDSPSignal(4);
iir(0) = 1.0000;
iir(1) =-1.8178;
iir(2) = 0.8689;
iir(3) = 0.0205;

f->IIR(iir);

cout << "the IIR-part of the filter     : " << iir << endl;

//
/////////////////////////////////////////////////////////////
//
Double_t n = filternorm(fir,iir,2);
cout << "the Norm of the filter         : " << n << endl;

//
/////////////////////////////////////////////////////////////
//
in  = new TDSPSignal(10000);
in->RandNC();

cout << endl;
cout << "Creating a complex Random Gaussian Vector" << endl;
cout << "The size of the vector is      : " << in->GetLen() << endl;
cout << "Power is                       : " << in->Power() << endl;
cout << "Filter-Norm                    : " << n << endl;

f->SetNorm(n);
f->Normalize();
cout << " (filter is now normalized)" << endl;
//
/////////////////////////////////////////////////////////////
//
cout << "Filtering ..."  << endl;
out = f->filter(in);
cout << "Output Power is                : " << out->Power() << endl;
cout << endl;
cout << "Diff. of Power is              : " << out->Power()-in->Power() << endl;
cout << endl << endl << "/////////////////////////////////////////////////////////////" << endl;
}
