{

gROOT->Reset();

#include <iostream.h>

TCanvas              *win = new TCanvas("Jakes","Jakes Model",900,500);
win->Divide(4);

Jakes = new TDSPJakes();
cout << "Configuring Jakes Model for the Stochastic Channel" << endl;
Jakes->SetCarrierFrequency(5.2e9);
cout << "  Carrier Frequ. = 5.2 GHz" << endl;
Jakes->SetSpeedKMH(20);
cout << "  Speed          = 20 km/h" << endl;
cout << "  Calculating ARMA-Model " << flush;
Jakes->SetMethod(kCorrFilterProny);
Jakes->Init(.1,100);
cout << "done" << endl;
cout << "  Filternorm is  = " << Jakes->GetNorm() << endl << endl;

cout << "(1) Testing this Filter with intern Test-Method " << endl;

win->cd(1);
Jakes->Test();

cout << "(2) Testing this Filter manually on a random gaussian input signal " << endl;

input = new TDSPSignal(10000);
input->RandNreal();

output = new TDSPSignal();

Jakes->filter(input,output);

win->cd(2);
autocor = output->XCorr(-100,kXCorrCoeff);
autocor->Draw("ac real");
gPad->Update();

cout << "(3) Testing this Filter on a random gaussian values " << endl;

fifofilter = new TDSPFifoFilter();
fifofilter->SetFilter(Jakes);
input1 = new TDSPSignal(10000);

for(Int_t i=0;i<input1->GetLen();++i) {
  input1(i) = fifofilter->filter(input(i));
  if (i%10) { cout << "    index=" << i << flush;cout << "\r"; };
}
cout << endl;

delete autocor;

win->cd(3);
autocor = input1->XCorr(-100,kXCorrCoeff);
autocor->Draw("ac real");



cout << "(4) Producing the same using TDSPStochasticScalar " << endl;


TDSPStochasticScalar StochasticVariable;
StochasticVariable->SetMode(kFilterGauss);
StochasticVariable->SetFifoFilter(fifofilter);

for(Int_t i=0;i<input1->GetLen();++i) {
  StochasticVariable->ChangeRepresentation();
  input1(i) = StochasticVariable->Value();
  if (i%10) { cout << "    index=" << i << flush;cout << "\r"; };
}
cout << endl;

delete autocor;

win->cd(4);
autocor = input1->XCorr(-100,kXCorrCoeff);
autocor->Draw("ac real");

}

}
