
{
  gROOT->Reset();

  // Starting the matlab engine 
  //
  m = new TMatlab();

  // Creating a TDSPSignal Vector "q"
  //
  q = new TDSPSignal(5);
  q(0) = TComplex(1,-1);
  q(1) = 1;
  q(2) = 2;
  q(3) = 3;
  q(4) = 4;

  cout << "Signal q = ";
  q->Print();
  
  // Creating an Matlab Vector "Q" and copy  
  // "q" it
  //
  TmxArray *Q = new TmxArray("Q");
  (*Q) =(*q);
  
  // Put the Matlab Vector in the running
  // Matlab Engine
  //
  m->Put(Q);
  
  
  // Make an evaluation and and create a new 
  // vector "T" in the matlab engine
  //
  m->Eval("T=cos(Q)");

  // Get the matlab Vector "T"
  //
  TmxArray *T = m->Get("T");
  
  // Create a copy of "T" as a TDSPSignal vector
  // named "t"
  //
  TDSPSignal t;

  t = *T;

  // Print the result 
  //
  cout << "Signal t = " << t << endl;
  
  // Plot the result using Matlab graphics
  //
  m->Eval("plot(Q,T);");

  
  cout << "Press Enter" << endl;
  getchar();

  cout << endl;
  cout << endl;

  cout << "Creating a Complex Random (normal distributed) Matrix Tma : " << endl;
  
  ma = new TDSPMatrix(5,3);
  ma->RandNC();
  cout << ma << endl;

  cout << "Put Tma in the matlab shell " << endl;

  Tma = new TmxArray("Tma");
  *Tma = *ma;
  m->Put(Tma);
  m->Eval("Tma");

  cout << endl << "Calculate Tmb = T*Tma" << endl;
  
  m->Eval("Tmb = T*Tma");

  cout << "Tmb = " << ma->LeftApply(&t) << endl;

  cout << "Tranposing the Matrix Tmc=Tma' " << endl;
  
  m->Eval("Tmc=Tma'");

  cout << "Retrieving Tmc from the Matlab Shell" << endl;
  
  Tmc = new TDSPMatrix();
  *Tmc=*(m->Get("Tmc"));

  cout << Tmc << endl;

  // Delete the TDSPSignal's
  //
  
  delete q;
  
  
  // Delete the Matlab Vectors's
  //

  delete T;
  delete Q;
  
  // Delete the Matlab Engine 
  //
  delete m;

}
