
{

  gROOT->Reset();
  
  
  Int_t l;
  Double_t ll;

  TMultiGraph tm;
  
  ////////////////////////////////////////////////////////////////
  //
  // PSK-Modulation
  //
  
  
  TGraph minPSK, meanPSK;
  
  for(Int_t i=0;i<30;++i) {
    
    l = (i+1)*2;
    
    TDSPPsk p("",l);
    
    
    cout << "(" << i << ") ";
    cout << l << "-PSK " << "mean=" << p.GetDistance("mean") << " min=" << p.GetDistance("mean");
    cout << endl;
    
    ll=l;
    minPSK.SetPoint( i,ll,p->GetDistance("min"));
    meanPSK.SetPoint(i,ll,p->GetDistance("mean"));
        
  }
  
  minPSK.SetLineColor(4);
  tm.Add(&minPSK);

  meanPSK.SetLineColor(4);
  meanPSK.SetLineStyle(2);
  tm.Add(&meanPSK);

  ////////////////////////////////////////////////////////////////
  //
  // QAM-Modulation
  //
  
  
  TGraph minQAM, meanQAM;

  for(Int_t i=0;i<4;++i) {
    
    l = 2*(i+1);
    l*=l;
    
    TDSPQam q("",l);
    
    
    cout << "(" << i << ") ";
    cout << l << "-QAM " << "mean=" << q.GetDistance("mean") << " min=" << q.GetDistance("mean");
    cout << endl;
    
    ll=l;
    minQAM.SetPoint( i,ll,q->GetDistance("min"));
    meanQAM.SetPoint(i,ll,q->GetDistance("mean"));
        
  }
  
  minQAM.SetLineColor(2);
  tm.Add(&minQAM);
  meanQAM.SetLineColor(2);
  meanQAM.SetLineStyle(2);
  tm.Add(&meanQAM);

  tm.SetTitle("Tests/Basic/modulation1.C");
  tm.Draw("ac");
  
  ////////////////////////////////////////////////////////////////
  //
  // Legende
  //
  
  TLegend le(0.6,0.7,0.89,0.89);;
  le.AddEntry(&minPSK,"n-PSK min","l");
  le.AddEntry(&meanPSK,"n-PSK mean","l");
  le.AddEntry(&minQAM,"n-QAM min","l");
  le.AddEntry(&meanQAM,"n-QAM mean","l");

  le.Draw();

}
