{
gROOT->Reset();
TDSPVector::LoadATLAS();

UInt_t  dim=400;
UInt_t dim1=400;
UInt_t dim2=300;

cout << "-----------------------------------------------------------------" << endl;
cout << "Benchmarking matrix multiplications ..." << endl;

a=RandNC(dim1,dim2,1.);
b=RandNC(dim2,dim1,1.);

// with atlas
//
TDSPVector::EnableATLAS();
gBenchmark->Reset();

cout << "using atlas matrix algebra" << endl;
gBenchmark->Reset();
gBenchmark->Start("mytimer");
c1a=a->RightApply(b);
c1b=b->LeftApply( a);
gBenchmark->Stop("mytimer");
gBenchmark->Print("mytimer");


// without atlas
//
TDSPVector::DisableATLAS();
cout << "using intern matrix algebra" << endl;
gBenchmark->Reset();
gBenchmark->Start("mytimer");
c2a=a->RightApply(b);
c2b=b->LeftApply( a);
gBenchmark->Stop("mytimer");
gBenchmark->Print("mytimer");

cout << "Difference (RightApply) = " << Dist(c1a,c2a) << endl;
cout << "Difference (LeftApply ) = " << Dist(c1b,c2b) << endl;
delete a;
delete b;
delete c1a;
delete c2a;
delete c1b;
delete c2b;

cout << "-----------------------------------------------------------------" << endl;
cout << "Benchmarking matrix-vector multiplications ..." << endl;

v= RandNC(dim*dim);
a= RandNC(dim,dim,1.);

// with atlas
//
TDSPVector::EnableATLAS();

cout << "using atlas matrix algebra" << endl;
gBenchmark->Reset();
gBenchmark->Start("mytimer");
v1a=a->RightApply(v);
gBenchmark->Stop("mytimer");
gBenchmark->Print("mytimer");

// without atlas
//
TDSPVector::DisableATLAS();
cout << "using intern matrix algebra" << endl;
gBenchmark->Reset();
gBenchmark->Start("mytimer");
v2a=a->RightApply(v);
gBenchmark->Stop("mytimer");
gBenchmark->Print("mytimer");


cout << "Difference = " << Dist(v1a,v2a) << endl;

delete v;
delete a;
delete v1a;
delete v2a;

}
