{
gROOT->Reset();

TDSPVector::ValuesPerLine(6);
TDSPSignal::ValuesPerLine(10);

cout << endl << "(1) Define a Matrix \"a\" and a Vector \"y\"" << endl;

a=new TDSPMatrix(5,5);
a(0,0) = 5;
a(1,2) = 1+2*I;
a(1,1) = 5;
a(2,2) = 2;
a(1,0) = 1;
a(0,1) = -1;
a(3,3) = 3+4*I;
a(3,4) = -5;
a(4,4) = -3+4*I;

cout << "        a=" << endl << a << endl; 
b=new TDSPVector(5);b(1)=2;
y=new TDSPVector(5);
y(0) = 2;
y(1) = 3;
y(2) = 4;
y(3) = 5;
y(4) = 6;
cout << "        y=" << y << endl; 

inv=a->Inverse();
y1=y->Dup();
*y1-=*b;
TDSPVector *x=x=inv->RightApply(y1);
cout << "   Det(a)=" << Det(a) << endl;
cout << "x=a^-1*(y-b)" << endl;
cout << "         =" << x  << endl;

///////////////////////////////////////////////////////////////////////

TDSPVector* g;

cout << endl << "(2) Creating a TDSPLinearSolver-Object" << endl;
cout <<         "    We Drop the initial guess (will be zero)" << endl;
cout <<         "    (or use TDSPLinearSolver::Guess() to set this!)" << endl;
TDSPVector ge(5);

s = new TDSPLinearSolver(a,b,y);

///////////////////////////////////////////////////////////////////////

cout << endl << "(3) Solving Ax+b=y with the Jacobi Method" << endl;

s->SetMethod(kLinearSolveJacobi);
s->Solve();

cout << "        x=" << s->GetX() << endl;
g=a->RightApply(s->GetX());(*g)+=*b;
cout << "  y'=ax+b=" << g << endl;
cout << "  (this needs " << s->GetIterations() << " iterations" << " the remaining error is " << s->GetPrecision() <<  ")" << endl;

///////////////////////////////////////////////////////////////////////

cout << endl << "(4) Solving Ax+b=y with the Gauss Seidel Method" << endl;

s->SetMethod(kLinearSolveGaussSeidel);
s->Solve();

cout << "        x=" << s->GetX() << endl;
g=a->RightApply(s->GetX());(*g)+=*b;
cout << "  y'=ax+b=" << g << endl;
cout << "  (this needs " << s->GetIterations() << " iterations" << " the remaining error is " << s->GetPrecision() << ")" << endl;


///////////////////////////////////////////////////////////////////////

cout << endl << "(5) Solving Ax+b=y with the Hard Decision Gauss Seidel Method (hard decision are unused)" << endl;

s->SetMethod(kLinearSolveGaussSeidelBinary);
cout <<         "    Serial HD = " << s->GetSerialHD() << endl;
cout <<         "  Parallel HD = " << s->GetParallelHD() << endl;
s->Solve();
cout << "        x=" << s->GetX() << endl;
g=a->RightApply(s->GetX());(*g)+=*b;
cout << "  y'=ax+b=" << g << endl;
cout << "  (this needs " << s->GetIterations() << " iterations" << " the remaining error is " << s->GetPrecision() << ")" << endl;


///////////////////////////////////////////////////////////////////////

cout << endl << "(6) Solving Ax+b=y with the CG Method" << endl;

cout << "    skipped..." << endl;

if (0) {
  
  s->SetMethod(kLinearSolveCG);
  s->Solve();
  
  cout << "        x=" << s->GetX() << endl;
  g=a->RightApply(s->GetX());(*g)+=*b;
  cout << "  y'=ax+b=" << g << endl;
  cout << "  (this needs " << s->GetIterations() << " iterations" << " the remaining error is " << s->GetPrecision() << ")" << endl;

}

///////////////////////////////////////////////////////////////////////

cout << endl << "(7) Creating a TDSPBlockSolve-Object and a TDSPBlockMap-Object" << endl;

bs = new TDSPBlockSolve();
bs->SetSolver(s);

ma = new TDSPBlockMap();
ma->SetMatrix(a);

r = new TDSPSignal(s->GetNumInputs()*20);
TDSPSignal *r1;

b->Zeros();

cout <<         "     - multiplying \"a\" blockwise with a random vector \"r\" of length " << r->GetLen() << endl;
cout <<         "     - find back \"r\" using the TDSPBlockSolve-Object ( here with GaussSeidel )" << endl;

for(Int_t i=0;i<5;i++) {
  r->RandNC();

  r1 = ma->Apply(r);
  r2 = bs->Solve(r1);
  
  cout << "    Accuracy  : "<< Dist(r,r2)/r->GetLen() << " (stop-precision was " << s->GetStopPrecision() << ")" << endl;


}

}
