{
gROOT->Reset();

cout << endl;
cout << "***************************************************" << endl;
cout << "* Demonstration of the \"TDSPFilterBank\"-Object *" << endl;
cout << "***************************************************" << endl;
cout << endl;

UInt_t N=32;
win = new TCanvas("win","Filterbank", 1024,768);
win->Clear();
win->Divide(2,3);

win->cd(1);
filter1 = Gaussnk(N);
filter1->SetTitle("Gaussian Impulse Response (filter 1)");
filter1->Draw("al");
filter1A=filter1->Adjoint();
filter1A->Reverse();

win->cd(2);
filter2 = Gaussnk(N);
filter2->ModulateMe(2*Pi*16./N);
filter2->SetTitle("Modulated Gaussian Impulse Response (filter 2)");
filter2->Draw("al");
filter2A=filter2->Adjoint();
filter2A->Reverse();

cout << "------------- Orthogonality between 2 filters --------------" << endl;
cout << "filter1.filter2=" << Dot(filter1,filter2) << endl;
cout << "------------- Synthesis filter Bank ------------------------" << endl;
TDSPFilterBank fi1(2,N);
fi1->SetFilter(0,filter1);
fi1->SetFilter(1,filter2);
fi1->SetSubSamplings(N);
fi1->Print();

cout << "------------- Analysis filter Bank ------------------------" << endl;
TDSPFilterBank fi2(2,N);
fi2->SetFilter(0,filter1A);
fi2->SetFilter(1,filter2A);
fi2->SetZero(N-1);
fi2->SetSubSamplings(N);
fi2->Print();
cout << "------------- The Input Signal ----------------------------" << endl;
win->cd(3);
in = new TDSPVector(44);
in->RandNC();
in->SetTitle(  "Input Sequence");
in->Draw("al*");
cout << "sent = " << endl << in << endl;

cout << "------------- The Output Signal ---------------------------" << endl;
win->cd(4);
out = fi1->Synthesize(in);
out->SetTitle( "Output Signal");
out->Draw("al");
cout << "Output signal len is = " << out->GetLen() << endl;

cout << "------------- The Reconstr. Signal ------------------------" << endl;

win->cd(5);
in1 = fi2->Analyze(out);
in1->SetTitle( "Reconstructed Sequence");
in1->Draw("al*");
cout << "rec. = " << endl << in1 << endl;

cout << "------------- The Diff.  Signal ----------------------------" << endl;

win->cd(6);
diff=in->SubBy(in1);
diff->SetTitle( "Reconstruction Error");
diff->Draw("al*");
cout << "diff = " << endl << diff << endl;

win->Update();



}
