{
gROOT->Reset();

cout << endl;
cout << "*******************************************************************" << endl;
cout << "* Demonstration of the DFT-Filterbank using TDSPFilterBank-Object *" << endl;
cout << "*******************************************************************" << endl;
cout << endl;

UInt_t Num=128 ; // Length of the input sequence
UInt_t N=32;    // SubSampling and pulse length
UInt_t M=8;     // Number of Modulations
UInt_t F=1;     // Frequency Spacing

win = new TCanvas("win","Filterbank", 1024,768);
win->Clear();
win->Divide(2,3);

win->cd(1);
filter1 = Gaussnk(N);
filter1->SetTitle("Gaussian Prototype");
filter1->Draw("al");

cout << "------------- Synthesis filter Bank ------------------------" << endl;
TDSPFilterBank fi1(M,N);
fi1->SetFreqPad(F);
fi1->InitFromProtoType("dft",filter1);
fi1->SetSubSamplings(N);
fi1->Print();

cout << "------------- Analysis filter Bank ------------------------" << endl;

TDSPFilterBank fi2(M,N);
fi2->SetMatrix(fi1->GetDualMatrix());
fi2->SetSubSamplings(N);
fi2->SetZero(N-1);
fi2->Print();

win->cd(2);
filter2 = fi2->GetFilter(0);
filter2->SetTitle("Dual Prototype");
filter2->Draw("al");


cout << "------------- The Input Signal ----------------------------" << endl;
win->cd(3);
in = new TDSPVector(Num);
in->RandNC();
in->SetTitle(  "Input Sequence");
in->Draw("al*");
cout << "sent = " << endl << in << endl;

cout << "------------- The Output Signal ---------------------------" << endl;
win->cd(4);
out = fi1->Synthesize(in);
out->SetTitle( "Output Signal");
out->Draw("al");
cout << "Output signal len is = " << out->GetLen() << endl;


cout << "------------- The Reconstr. Signal ------------------------" << endl;

win->cd(5);
in1 = fi2->Analyze(out);
in1->SetTitle( "Reconstructed Sequence");
in1->Draw("al*");
cout << "rec. = " << endl << in1 << endl;

cout << "------------- The Diff.  Signal ----------------------------" << endl;

win->cd(6);
diff=in->SubBy(in1);
diff->SetTitle( "Reconstruction Error");
diff->Draw("al*");
cout << "diff = " << endl << diff << endl;

win->Update();



}
