{

gROOT->Reset();
gErrorIgnoreLevel = kWarning;

#include <iostream.h>

cout << endl << "Plotting the LMMSE-Estimator - Channel=1, AWGN" << endl << endl;

TDSPNofdm            *no = new TDSPNofdm("no"); // NOFDM Transmitter and Receiver

// Init the Gabor System
//
no->SetLength(80);
no->SetPads(8,8);
no->Init();


// The Channel-Model (a square matrix)
//
TDSPMatrix *H   =  UnitMatrix(no->GetMatrix()->GetRows()); // The Channel

// Configure the NOFDM-Receiver to be a correlating receiver
//
no->SetOption("corr");
no->SetChannel(H);


// Create and Configure the LMMSE
//
TDSPLmmse   *lmmse  = new TDSPLmmse(no->GetCorrelation(),          // The mapping
				    UnitMatrix(no->GetBlockLen()), // The symbol covariance
				    no->GetNoiseCorrelation());    // The Noise-Covariance

lmmse->SetNoise(0);

// Create a Window
//
TCanvas              *win = new TCanvas("Lmmse","LMMSE-Estimator in AWGN-Channel",600,600);


for(Double_t n=0;n<1;n+=.1) {
  lmmse->SetNoise(n);
  lmmse->Calculate();
  lmmse->GetEstimatorMatrix()->Draw("hist cont");
  win->Update();
  cout << "noise=" << n << " - Press Enter ..." << flush;
  getchar();
}
return;

}
