

{

  gROOT->Reset();
  gErrorIgnoreLevel = kError;
  
  cout << endl << "Checking different Cyclic Prefixes" << endl << endl;
  
  // Creating objects

  TDSPOfdm            *no = new TDSPOfdm("no");
  TDSPPsk             *qm = new TDSPPsk("qm",4);
  cout << "Using Qpsk Modulation" << endl;

  TDSPAwgn            *aw = new TDSPAwgn("aw");

  // Make Connections
  
  if (!qm->Connect(    "Update(TDSPSignal*)",     no,"Transmit(TDSPSignal*)")) Error("","");
  if (!no->Connect(    "Transmitted(TDSPSignal*)",aw,"Update(TDSPSignal*)")) Error("","");
  if (!aw->Connect(    "Update(TDSPSignal*)",     no,"Receive(TDSPSignal*)")) Error("","");
  if (!no->Connect(    "Received(TDSPSignal*)",   qm,"Update(TDSPSignal*)")) Error("","");


  Double_t n=1/FromdB(6);
  aw->SetNoisePower(n);
  cout << " awgn noise                 = " << n << endl;

  Int_t    c=128;
  no->SetBlockLen(c);
  cout << " number of carriers         = " << c << endl;

  Int_t    s=512000;
  cout << " number of symbols per run  = " << s << endl;
  qm->SetSignalLength(s);
  
  for(Int_t i=0;i<=64;i+=16) {

      
    no->SetCyclicPrefix(i);
    
    qm->Generate();
    
    cout << " Cyclic Prefix Length = " << i;
    cout << " NoisePower(set=" << n << ",";
    cout << " mea.=" << qm->fNoisePower << ")";
    cout << " SNR = " << aw->GetSNR() << " dB";
    cout << " SER = " << qm->fInEfficiency;
    cout << " Misid.=" << qm->fMisIdentified << endl;
   
  }
  
  printf("ready\n"); 

}
