

{
  
  gROOT->Reset();
  gErrorIgnoreLevel = kError;

  cout <<  "Checking different OFDM-Oversamplings in an AWGN-Channel" << endl << endl;
  
  TDSPOfdm            *no = new TDSPOfdm("no");

  TDSPPsk              *qm = new TDSPPsk("qm",4);
  cout << "Using Qpsk Modulation" << endl;

  TDSPAwgn             *aw = new TDSPAwgn("aw");

  
  if (!qm->Connect(    "Update(TDSPSignal*)",     no,"Transmit(TDSPSignal*)")) Error("","");
  if (!no->Connect(    "Transmitted(TDSPSignal*)",aw,"Update(TDSPSignal*)")) Error("","");
  if (!aw->Connect(    "Update(TDSPSignal*)",     no,"Receive(TDSPSignal*)")) Error("","");
  if (!no->Connect(    "Received(TDSPSignal*)",   qm,"Update(TDSPSignal*)")) Error("","");

  Double_t n=.16;
  aw->SetNoisePower(n);
  cout << " awgn noisepower            = " << n << endl;

  Int_t    c=128;
  no->SetBlockLen(c);
  cout << " number of carriers         = " << c << endl;

  Int_t    s=512000;  
  qm->SetSignalLength(s);
  qm->SetAnalyseGrid(s);
  cout << " number of symbols per run  = " << s << endl;
   
  
  for(Int_t i=1;i<=8;i++) {

      
    no->SetOverSampling(i);
    
    gBenchmark->Start("qm");
    qm->Generate();
    gBenchmark->Stop("qm");
    
    cout << " oversampling = " << i << " :";
    cout << " NoisePower(set=" << n << ",";
    cout << " mea.=" << qm->fNoisePower << ")";
    cout << " SNR= " << aw->GetSNR() << " dB";
    cout << " SER = " << qm->fInEfficiency;
    cout << " Misid.=" << qm->fMisIdentified;
    cout << " time="<< gBenchmark->GetRealTime("qm") << endl;
   
  }
  
  printf("ready\n");

}
