{

gROOT->Reset();


TDSPFastBpsk         *qm = new TDSPFastBpsk();
TDSPOfdm             *of = new TDSPOfdm();
TDSPAwgn             *aw = new TDSPAwgn();
TDSPClip             *cl = new TDSPClip();
TDSPBlockfft         *ff = new TDSPBlockfft();

TCanvas win("win","",800,600);
win->SetLogy();

///////////////////////////////////////////////////////////////////////////
//
// Connections
//
qm->SetOption("dump0");
qm->Connect(of,"Transmit(TDSPSignal*)");
of->Connect("Transmitted(TDSPSignal*)",cl,"Update(TDSPSignal*)");
cl->Connect(aw);
aw->Connect(ff,"FFT(TDSPSignal*)");

///////////////////////////////////////////////////////////////////////////
//
// Configurations
//
Double_t ov = 4;
cl->SetClip(.4);
of->SetNumCarriers(512);
of->SetOverSampling(ov);
aw->SetNoisePower(.01);
ff->SetBlockLen(of->GetNumCarriers()*ov);

///////////////////////////////////////////////////////////////////////////
//
// Generate Signal
//

qm->SetSignalLength(of->GetNumCarriers()*200);
qm->Generate();

///////////////////////////////////////////////////////////////////////////
//
// Calculate the Mean Power Spectrum
//

meanpower = TDSPBlockOperation::MeanPower(of->GetNumCarriers()*ov, ff->GetFFTSignal());
meanpower->FFTShiftMe();

///////////////////////////////////////////////////////////////////////////
//
// Draw the Spectrum
//

gr = meanpower->Graph("abs",NULL,
		      2*TMath::Pi()/meanpower->GetLen(),
		      -TMath::Pi());

gr->Draw("al");
gr->SetTitle("Spectrum of clipped BPSK-OFDM-Signal"); 
gr->GetXaxis()->SetTitle("#omega");
gr->GetYaxis()->SetTitle("P_{s}");
gr->Draw("al");

win->Update();

}
