{

gROOT->Reset();
gErrorIgnoreLevel = kWarning;
#include <iostream.h>

  // The Symbol Generator should be Qam16
  
  TDSPQam         *Qam      = new TDSPQam("Qam",16);
  Qam->SetSignalLength(100);
  Qam->SetAnalyseGrid(100);

  // The Channel is simple convolution

  TDSPConvolution *Channel  = new TDSPConvolution("Channel");

  // Connect them

  Qam->Connect(    "Update(TDSPSignal*)", Channel, "Update(TDSPSignal*)");
  Channel->Connect("Update(TDSPSignal*)", Qam    , "Update(TDSPSignal*)");
  
  // Create a Stochastic Channel Function, with 10 pads

  Int_t pads = 10;
  TDSPStochasticSignal *ChannelResponse = new TDSPStochasticSignal(pads);
  
  // Create the means values (to be gaussian)

  ChannelResponse->Delta();

  cout << "Creating a Delta channel function with " << pads << " pads" << endl;
  cout << "ChannelResponse = " << endl;
  ChannelResponse->Print();
  
  cout << "Using this as Model (as the mean values...)" << endl;

  ChannelResponse->SetAsModel();
  ChannelResponse->SetMode(kGauss);

  // Configure the stochastic Channel Response to be gaussian, uncorrelated
  // with a special sigma

  Double_t sigma = .03;
  cout << "Setting now this to a gaussian stochastic process with sigma = " << sigma << endl;

  ChannelResponse->SetSigmas(TComplex(sigma,sigma));
 
  // Connect the Stochastic ChannelResponse to the Channel

  Channel->Response(ChannelResponse);
  
  // Create some in/out views

  TDSPSignalView  *Input    = new TDSPSignalView("Input", "Input Signal", "real ab");
  TDSPSignalView  *Output   = new TDSPSignalView("Output","Output Signal","complex a*");
  
  // Connect the views

  Qam->Connect(    "Update(TDSPSignal*)", Input,   "Update(TDSPSignal*)");
  Channel->Connect("Update(TDSPSignal*)", Output,  "Update(TDSPSignal*)");

  
  for(Int_t i=0;i<100;i++) {    
    Qam->Generate();
    cout << " SNR = "  << Qam->fSNR ;
    cout << " dB SER = " << Qam->fInEfficiency;
    cout << " Misid.=" << Qam->fMisIdentified << "\n";
  }
  
}
