/** TDSP *******************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mon Sep 10 15:30:51 CEST 2001
    copyright            : (C) 2001 by Peter Jung
    email                : jung@hhi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <stdlib.h>
#include <string.h>
#include <G__ci.h>
#include <TSystem.h>
#include <TError.h>
#include "TDSPGlobals.h"
#include "Base/TDSPInt.h"
#include "Controls/TDSPOperatorControl.h"

TDSPOperatorControl o;

#define BUFLEN      1024
#define ALL_DIR_LEN 4096


void  disable_gcc_Wall() {

  //#ifdef _GCC_
  TString      s = gSystem->GetMakeSharedLib();
  Ssiz_t       p = s.Index("-Wall");
  if (p!=kNPOS) {
    s.Replace(p,5,"-w");
    gSystem->SetMakeSharedLib(s.Data());
    Info("disable_gcc_Wall","Disabling all Compiler Warnings");
  }
  //#endif

}

char *add_include_path(char *path, char *subdir,char *all_dirs) {
  static char buf[BUFLEN];
  strncpy(buf,path,BUFLEN);
  strcat(buf,subdir);
 
  if (gSystem->OpenDirectory(buf)) {
    strcat(all_dirs," -I");
    strcat(all_dirs,buf);
    return buf;
  }
  Error("main","Can set Include Path to %s !",buf);
  return NULL;
}

int main(int argc, char *argv[]) {
  
  char *Installation_Dir=NULL;
  char all_dirs[ALL_DIR_LEN];
  *all_dirs=0;


  Init_Globals();
  disable_gcc_Wall();
  G__loadfile("Riostream.h");

  if ((Installation_Dir = getenv("TDSP"))) {
    if (!add_include_path(Installation_Dir,"/include",all_dirs)) {
   
      Error("main","This is not a correctly installed Tdsp");
      add_include_path(Installation_Dir,"",all_dirs);
      add_include_path(Installation_Dir,"/tdsp/Base",all_dirs);
      add_include_path(Installation_Dir,"/tdsp/Controls",all_dirs);
      add_include_path(Installation_Dir,"/tdsp/TGObjects",all_dirs);
      add_include_path(Installation_Dir,"/tdsp/TQQObjects",all_dirs);
      add_include_path(Installation_Dir,"/tdsp/Matlab",all_dirs);
      add_include_path(Installation_Dir,"/tdsp/LinAlg",all_dirs);
    } 
    if (*all_dirs) gSystem->SetIncludePath(all_dirs);
    
  } else {
    Error("main","You should define TDSP - environment variable pointing to your top tdsp-installation !!");
    Error("main","%s",argv[0]);
  }
  TDSPInt TDSPInterpreter("tdsp",&argc,argv);
  TDSPInterpreter.Run();

  return EXIT_SUCCESS;
  
}
